%define libbonobo_version 2.2.0
%define gconf2_version 1.2.0
%define gtkdoc_version 0.9
%define gnome_mime_data_version 2.0.0-11
%define redhat_menus_version 0.30

%define po_package gnome-vfs-2.0

Summary: The GNOME virtual file-system libraries.
Name: gnome-vfs2
Version: 2.2.5
Release: 2E.1.XOS.1
License: LGPL
Group: System Environment/Libraries
Source: gnome-vfs-%{version}.tar.bz2
Source2: vfolder-desktop-method.c
Source3: desktop-method.c
URL: http://www.gnome.org/
BuildRoot:      %{_tmppath}/%{name}-%{version}-root
Requires:      gnome-mime-data >= %{gnome_mime_data_version}
Requires:      redhat-menus >= %{redhat_menus_version}
BuildRequires: libbonobo-devel >= %{libbonobo_version}
BuildRequires: GConf2-devel >= %{gconf2_version}
BuildRequires: gnome-mime-data >= %{gnome_mime_data_version}
BuildRequires: bonobo-activation-devel, glib2-devel, libxml2-devel, zlib-devel
BuildRequires: popt, bzip2-devel, ORBit2-devel, XFree86-devel, openjade
BuildRequires: pkgconfig
BuildRequires: gnome-mime-data >= %{gnome_mime_data_version}
BuildRequires: /usr/bin/automake-1.4
BuildRequires: gtk-doc >= %{gtkdoc_version}
Prereq: GConf2 >= %{gconf2_version}


Patch1: gnome-vfs-1.9.4.91-docdir.patch
Patch2: gnome-vfs-2.1.3-moved-menu-files.patch
Patch3: gnome-vfs-2.0.4-onlyshowin.patch

Patch5: gnome-vfs-1.9.16-moved-menu-files.patch
Patch6: gnome-vfs-2.0.1-only-show-in.patch
Patch7: gnome-vfs-2.1.6-modules-conf.patch
Patch8: gnome-vfs-2.0.2-newstat.patch
Patch9: gnome-vfs-2.0.2-read-only.patch

## this is the automake-requiring patch
Patch10: gnome-vfs-2.1.6-old-modules.patch

Patch11: gnome-vfs-2.1.6-network-uri.patch
Patch12: gnome-vfs-2.1.6-never-show-if-empty.patch
Patch13: gnome-vfs-2.1.6-hide-with-empty-subfolders.patch
Patch14: gnome-vfs-2.1.6-no-private-methods.patch

Patch15: gnome-vfs-2.2.0-vfolder-hacks.patch

%description
GNOME VFS is the GNOME virtual file system. It is the foundation of
the Nautilus file manager. It provides a modular architecture and
ships with several modules that implement support for file systems,
http, ftp, and others. It provides a URI-based API, backend
supporting asynchronous file operations, a MIME type manipulation
library, and other features.

%package devel
Summary: Libraries and include files for developing GNOME VFS applications.
Group: Development/Libraries
Requires:   %{name} = %{version}
Requires:   GConf2-devel >= %{gconf2_version}
Requires:   libbonobo-devel >= %{libbonobo_version}
Conflicts: bonobo-devel < 1.0.8
Conflicts: gnome-vfs-devel < 1.0.2

%description devel
This package provides the necessary development libraries for writing
GNOME VFS modules and applications that use the GNOME VFS APIs.

%prep
%setup -q -n gnome-vfs-%{version}

cp -f %{SOURCE2} modules
cp -f %{SOURCE3} modules

# Patch1: gnome-vfs-1.9.4.91-docdir.patch modifies doc/Makefile.am
#%patch1 -p1 -b .docdir

(cd modules && cp default-modules.conf default-modules.conf.with-menu-editing)

## clean out the methods that don't work with our setup
DMC=modules/default-modules.conf.with-menu-editing
perl -pi -e 's/all-applications:\s+libvfolder-desktop.so//g' $DMC
perl -pi -e 's/all-preferences:\s+libvfolder-desktop.so//g' $DMC
perl -pi -e 's/favorites:\s+libvfolder-desktop.so//g' $DMC
perl -pi -e 's/network:\s+libvfolder-desktop.so//g' $DMC

## these two should actually work
## perl -pi -e 's/applications-all-users:\s+libvfolder-desktop.so//g' $DMC
## perl -pi -e 's/preferences-all-users:\s+libvfolder-desktop.so//g' $DMC

## these are now in the vfolder-hacks patch
#%patch2 -p1 -b .moved-menu-files
#%patch3 -p0 -b .onlyshowin

%patch5 -p1 -b .moved-menu-files
%patch6 -p1 -b .only-show-in
%patch7 -p1 -b .modules-conf
%patch8 -p1 -b .newstat
%patch9 -p1 -b .read-only
%patch10 -p1 -b .old-modules
%patch11 -p1 -b .network-uri
%patch12 -p1 -b .never-show-if-empty
%patch13 -p1 -b .hide-with-empty-subfolders
%patch14 -p1 -b .no-private-methods

%patch15 -p0 -b .vfolder-hacks

%build
# needed for patch10 (changing makefile to old vfolder backend)
automake-1.4
if pkg-config openssl ; then
	CPPFLAGS=`pkg-config --cflags openssl`; export CPPFLAGS
	LDFLAGS=`pkg-config --libs-only-L openssl`; export LDFLAGS
fi
%configure

make LIBTOOL=/usr/bin/libtool

%install
rm -fr %{buildroot}

export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
%makeinstall LIBTOOL=/usr/bin/libtool
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL

rm -f $RPM_BUILD_ROOT%{_libdir}/gnome-vfs-2.0/modules/lib*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la

rm -f $RPM_BUILD_ROOT%{_sysconfdir}/gnome-vfs-2.0/vfolders/*.vfolder-info
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/gnome-vfs-2.0/vfolders/*.vfolder-info-default

## why, dear god, why?
rm -f $RPM_BUILD_ROOT%{_datadir}/aclocal/gob2.m4

install -m 644 modules/default-modules.conf.with-menu-editing $RPM_BUILD_ROOT%{_sysconfdir}/gnome-vfs-2.0/modules/

## Remove this line and update file list to revert to
## no-menu-editing-by-default
# (cd $RPM_BUILD_ROOT%{_sysconfdir}/gnome-vfs-2.0/modules/; mv default-modules.conf default-modules.conf.without-menu-editing; mv default-modules.conf.with-menu-editing default-modules.conf)

rm -f $RPM_BUILD_ROOT%{_libdir}/bonobo/monikers/*.{a,la}

# remove all traces of extfs
rm -f $RPM_BUILD_ROOT%{_libdir}/gnome-vfs-2.0/modules/libextfs.*
perl -pi -e 's|.*extfs.*$||s' $RPM_BUILD_ROOT%{_sysconfdir}/gnome-vfs-2.0/modules/default-modules.conf
rm -rf $RPM_BUILD_ROOT%{_libdir}/vfs/2.0/extfs


%find_lang %{po_package}

%clean
rm -fr %{buildroot}

%post

export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
SCHEMAS="system_http_proxy.schemas"
for S in $SCHEMAS; do
  gconftool-2 --makefile-install-rule %{_sysconfdir}/gconf/schemas/$S > /dev/null
done

/sbin/ldconfig

%postun -p /sbin/ldconfig

%files -f %{po_package}.lang
%defattr(-, root, root)
%doc AUTHORS COPYING ChangeLog NEWS README

%dir %{_sysconfdir}/gnome-vfs-2.0
%dir %{_sysconfdir}/gnome-vfs-2.0/modules
#%dir %{_sysconfdir}/gnome-vfs-2.0/vfolders
%config %{_sysconfdir}/gnome-vfs-2.0/modules/*.conf
%config %{_sysconfdir}/gnome-vfs-2.0/modules/*.conf.with-menu-editing
## we aren't really using the .vfolder-info config files, 
## so installing them is a little misleading.
## %config %{_sysconfdir}/gnome-vfs-2.0/vfolders/*.vfolder-info
## %config %{_sysconfdir}/gnome-vfs-2.0/vfolders/*.vfolder-info-default
%{_libdir}/*.so.*
%{_libdir}/gnome-vfs-2.0/modules
%dir %{_libdir}/gnome-vfs-2.0
%{_libdir}/bonobo
%{_libdir}/vfs
%{_sysconfdir}/gconf/schemas/*
## conflicts with gnome-vfs 1, ignore for now
## %{_datadir}/man/man5/*

%files devel
%defattr(-, root, root)
%{_libdir}/lib*.a
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*
%{_libdir}/gnome-vfs-2.0/include/*.h
%{_includedir}/*
%{_datadir}/gtk-doc

%changelog
* Fri Aug 20 2004 X/OS Linux Team <xoslinux@xos.nl> 2.2.5-2E.1.XOS.1
- Build for X/OS Linux 3.0.
- X/OS Linux source rpm based on gnome-vfs2-2.2.5-2E.1.src.rpm
  (md5sum of original source rpm: fbcb6e48b0e04a54383894867a79057d).

* Mon Jul  5 2004 Alexander Larsson <alexl@redhat.com> - 2.2.5-2E.1
- Remove extfs (#127262)

* Tue Jul  8 2003 Alexander Larsson <alexl@redhat.com> 2.2.5-2.E
- Rebuild

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue May 27 2003 Alexander Larsson <alexl@redhat.com> 2.2.5-1
- Update to 2.2.5

* Mon Mar 31 2003 Alexander Larsson <alexl@redhat.com> 2.2.4-1
- Update to 2.2.4

* Mon Feb 24 2003 Elliot Lee <sopwith@redhat.com>
- debuginfo rebuild

* Mon Feb 24 2003 Alexander Larsson <alexl@redhat.com> 2.2.2-3
- Added patch to fix smb crash (#84982)

* Mon Feb 24 2003 Alexander Larsson <alexl@redhat.com> 2.2.2-2
- Add patch to fix notify race (#84668)

* Wed Feb 12 2003 Alexander Larsson <alexl@redhat.com> 2.2.2-1
- 2.2.2, fixes bad memleak (#83791)

* Tue Feb 11 2003 Havoc Pennington <hp@redhat.com> 2.2.1-3
- kill menu editing again, it was very very broken

* Mon Feb 10 2003 Bill Nottingham <notting@redhat.com> 2.2.1-2
- fix file list (#68226)
- prereq GConf2

* Mon Feb 10 2003 Alexander Larsson <alexl@redhat.com> 2.2.1-1
- Update to 2.2.1. fixes gnome-theme-manager hang

* Thu Feb  6 2003 Havoc Pennington <hp@redhat.com> 2.2.0-7
- move to menu editing modules.conf by default, we'll see if it works

* Tue Jan 28 2003 Matt Wilson <msw@redhat.com> 2.2.0-6
- use LIBTOOL=/usr/bin/libtool

* Mon Jan 27 2003 Havoc Pennington <hp@redhat.com>
- it would help to *install* the stupid menu edit conf file
- update the vfolder-hacks patch with some fixes

* Fri Jan 24 2003 Havoc Pennington <hp@redhat.com>
- hack up editable vfolder backend to maybe work
  (still not the default config file)

* Wed Jan 22 2003 Havoc Pennington <hp@redhat.com>
- include a non-default config file to use new vfolder method
- build the new vfolder method

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Jan 21 2003 Alexander Larsson <alexl@redhat.com>
- Update to 2.2.0

* Mon Jan 13 2003 Havoc Pennington <hp@redhat.com>
- variation on the subfolders hack to try to fix it

* Sat Jan 11 2003 Havoc Pennington <hp@redhat.com>
- fix bug where empty folders with empty subfolders would
  still be visible.

* Sat Jan 11 2003 Havoc Pennington <hp@redhat.com>
- finish adapting desktop-method.c to underscore-prefixing action

* Sat Jan 11 2003 Havoc Pennington <hp@redhat.com>
- adapt desktop-method.c to underscore-prefixing action

* Sat Jan 11 2003 Havoc Pennington <hp@redhat.com>
- hardcode <DontShowIfEmpty>, it's stupid to ever override this.

* Sat Jan 11 2003 Havoc Pennington <hp@redhat.com>
- make network:/// use libdesktop.so, and modify libdesktop.so 
  to support it

* Sat Jan 11 2003 Havoc Pennington <hp@redhat.com>
- Revert to George's vfolder backend from gnome-vfs-2.0.2 or so
- put back libdesktop.so
- don't build the new vfolder backend

* Wed Jan  8 2003 Alexander Larsson <alexl@redhat.com> 2.1.6-2
- Removed __libdir fix that was fixed upstream

* Wed Jan  8 2003 Alexander Larsson <alexl@redhat.com> 2.1.6-1
- Update to 2.1.6

* Tue Jan  7 2003 Nalin Dahyabhai <nalin@redhat.com> 2.1.5-3
- rebuild

* Mon Dec 16 2002 Tim Powers <timp@redhat.com> 2.1.5-2
- rebuild

* Mon Dec 16 2002 Alexander Larsson <alexl@redhat.com> 2.1.5-1
- Update to 2.1.5

* Thu Dec 12 2002 Nalin Dahyabhai <nalin@redhat.com>
- use OpenSSL's pkg-config information, if available

* Wed Dec  4 2002 Havoc Pennington <hp@redhat.com>
- 2.1.3.1

* Sun Nov 10 2002 Havoc Pennington <hp@redhat.com>
- 2.1.3
- update moved-menu-files patch

* Wed Oct 23 2002 Havoc Pennington <hp@redhat.com>
- add patch for OnlyShowIn support
- use plain menu files for .vfolder-info-default
- don't install unused vfolder-info files

* Tue Oct  8 2002 Havoc Pennington <hp@redhat.com>
- require new gnome-mime-data in proper libdir
- 2.0.4
- drop most patches as they are now upstream or 
  don't apply to new vfolder code

* Fri Aug 30 2002 Owen Taylor <otaylor@redhat.com>
- Backport a gnome-vfs locking fix from CVS 
  (Hopefully fixes #71419)

* Fri Aug 23 2002 Havoc Pennington <hp@redhat.com>
- make vfolder method read-only #72208

* Mon Aug 19 2002 Jonathan Blandford <jrb@redhat.com>
- notice when new files are installed

* Tue Aug 13 2002 Havoc Pennington <hp@redhat.com>
- don't include pointless .a files

* Fri Aug  2 2002 Havoc Pennington <hp@redhat.com>
- 2.0.2
- use vfolders for system-settings and server-settings

* Tue Jul 16 2002 Havoc Pennington <hp@redhat.com>
- fix OnlyShowIn

* Tue Jun 25 2002 Owen Taylor <otaylor@redhat.com>
- Version 2.0.1, fix missing po files

* Sun Jun 16 2002 Havoc Pennington <hp@redhat.com>
- 2.0.0
- put schema files in file list, and install them
- put libdir/vfs in file list

* Tue Jun 11 2002 Havoc Pennington <hp@redhat.com>
- rebuild in different environment

* Tue Jun 11 2002 Havoc Pennington <hp@redhat.com>
- look for menus in redhat-menus

* Fri Jun 07 2002 Havoc Pennington <hp@redhat.com>
- rebuild in different environment

* Wed Jun  5 2002 Havoc Pennington <hp@redhat.com>
- 1.9.16

* Sun May 26 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon May 20 2002 Havoc Pennington <hp@redhat.com>
- rebuild in different environment

* Mon May 20 2002 Havoc Pennington <hp@redhat.com>
- 1.9.15
- comment out docdir patch for now

* Fri May  3 2002 Havoc Pennington <hp@redhat.com>
- 1.9.14

* Thu Apr  4 2002 Jeremy Katz <katzj@redhat.com>
- 1.9.11
- update file list

* Thu Feb 14 2002 Havoc Pennington <hp@redhat.com>
- 1.9.7

* Thu Jan 31 2002 Owen Taylor <otaylor@redhat.com>
- Fix location of installed docs not to conflict with gnome-vfs1

* Wed Jan 30 2002 Owen Taylor <otaylor@redhat.com>
- Rebuild with new libs

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu Jan  3 2002 Havoc Pennington <hp@redhat.com>
- 1.0.4.91 snap

* Mon Nov 26 2001 Havoc Pennington <hp@redhat.com>
- 1.9.4.90 snap
- require gnome-mime-data

* Sun Oct 28 2001 Havoc Pennington <hp@redhat.com>
- new snap, rebuild for glib 1.3.10

* Fri Oct  5 2001 Havoc Pennington <hp@redhat.com>
- cvs snap

* Fri Sep 21 2001 Havoc Pennington <hp@redhat.com>
- rebuild cvs snap with changes merged upstream
- fix a requires
- fix up requires/buildrequires a bit

* Tue Sep 18 2001 Havoc Pennington <hp@redhat.com>
- initial gnome-vfs2 build, remove all patches
- change config files not to be noreplace

* Mon Aug 27 2001 Havoc Pennington <hp@redhat.com>
- Add po files from sources.redhat.com

* Mon Aug 20 2001 Havoc Pennington <hp@redhat.com>
- fix #51864 (Gimp can't handle file: URIs)

* Mon Aug 20 2001 Alexander Larsson <alexl@redhat.com> 1.0.1-15
- Moved gnome-conf and pkgconfig files to the devel package
- Fixes SHOULD-FIX bug #49795

* Mon Aug  6 2001 Alexander Larsson <alexl@redhat.com> 1.0.1-14
- Added a patch that fixed AbiWord mimetype handling.

* Fri Jul 27 2001 Jonathan Blandford <jrb@redhat.com>
- Add .desktop file sniffing

* Tue Jul 24 2001 Havoc Pennington <hp@redhat.com>
- don't do the giant trash scan thing; did not play nice
  with NFS.

* Tue Jul 24 2001 Havoc Pennington <hp@redhat.com>
- fix desktop-file.conf file

* Tue Jul 24 2001 Havoc Pennington <hp@redhat.com>
- change some URI scheme names

* Fri Jul 20 2001 Alexander Larsson <alexl@redhat.com>
- Add pkgconfig and gnome-libs-devel build reqs.
- Remove dependency on gnome-vfs-devel by doing some
- CPPFLAGS and LDFLAGS magic

* Wed Jul 11 2001 Havoc Pennington <hp@redhat.com>
- add missing directories

* Tue Jul 10 2001 Havoc Pennington <hp@redhat.com>
- fix a segv
- change which dirs the desktop VFS module points to

* Sun Jul 08 2001 Havoc Pennington <hp@redhat.com>
- add desktop VFS module hack

* Fri Jul  6 2001 Trond Eivind Glomsrd <teg@redhat.com>
- Remove Distribution and Vendor
- Make the config files noreplace
- Move .so links to devel subpackage
- langify
- Add BuildRequires
- Don't mess with /etc/ld.so.conf
- Use %%{_tmppath}
- s/Copyright/License/

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.

* Wed May  9 2001 Jonathan Blandford <jrb@redhat.com>
- New Version.

* Tue Apr 17 2001 Jonathan Blandford <jrb@redhat.com>
- New Version.
- clean up spec file some.

* Mon Feb 19 2001 Gregory Leblanc <gleblanc@cu-portland.edu>
- fix paths and macros

* Tue Feb 22 2000 Ross Golder <rossigee@bigfoot.com>
- Integrate into source tree
